﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Threading;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace AntiAFK
{
    public class AntiAFK : HBPlugin
    {
        public override string Name { get { return "Anti AFK"; } }
        public override string Author { get { return "Rozman"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return false; } }

        private static readonly Stopwatch timerAccept = new Stopwatch();
        private int AcceptingTime = 0;

        public override void OnEnable()
        {
            base.OnEnable();

            Logging.Write("[Anti AFK " + Version + "] Enabled");
        }

        public override void OnDisable()
        {
            Logging.Write("[Anti AFK " + Version + "] Disabled");

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptingTime = 0;

            base.OnDisable();
        }

        public override void Pulse()
        {
            if (!StyxWoW.IsInGame) return;

			if (!timerAccept.IsRunning) {
                Random r = new Random();

                AcceptingTime = r.Next(240000, 420000);
                //AcceptingTime = r.Next(10000, 20000);

			    timerAccept.Start();
			}

			if (timerAccept.ElapsedMilliseconds < AcceptingTime)
			{
				return;
			}

            WoWMovement.Move(WoWMovement.MovementDirection.JumpAscend, TimeSpan.FromSeconds(1));

            timerAccept.Stop();
            timerAccept.Reset();
            AcceptingTime = 0;
        }
    }
}